<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'SeedDataDescription' => '\\StructType\\SeedDataDescription',
            'LoadData' => '\\StructType\\LoadData',
            'UpdateData' => '\\StructType\\UpdateData',
            'SubmitData' => '\\StructType\\SubmitData',
            'Table' => '\\StructType\\Table',
            'DataTable' => '\\StructType\\DataTable',
            'UpdateTable' => '\\StructType\\UpdateTable',
            'SubmitTable' => '\\StructType\\SubmitTable',
            'DataRow' => '\\StructType\\DataRow',
            'UpdateRow' => '\\StructType\\UpdateRow',
            'SubmitRow' => '\\StructType\\SubmitRow',
            'Field' => '\\StructType\\Field',
            'DataField' => '\\StructType\\DataField',
            'Link' => '\\StructType\\Link',
            'DataLink' => '\\StructType\\DataLink',
            'LinkRef' => '\\StructType\\LinkRef',
            'AttachmentList' => '\\StructType\\AttachmentList',
            'Attachment' => '\\StructType\\Attachment',
            'AuditReportList' => '\\StructType\\AuditReportList',
            'AttributeAuditNode' => '\\StructType\\AttributeAuditNode',
            'RelationshipAuditNode' => '\\StructType\\RelationshipAuditNode',
            'EntityAuditNode' => '\\StructType\\EntityAuditNode',
            'ReferenceAuditNode' => '\\StructType\\ReferenceAuditNode',
            'ReferenceTagList' => '\\StructType\\ReferenceTagList',
            'ReferenceTag' => '\\StructType\\ReferenceTag',
            'UnknownValue' => '\\StructType\\UnknownValue',
            'UncertainValue' => '\\StructType\\UncertainValue',
            'ChangePoint' => '\\StructType\\ChangePoint',
            'RequestContext' => '\\StructType\\RequestContext',
            'RequestContextParam' => '\\StructType\\RequestContextParam',
            'check-alive-request' => '\\StructType\\Check_alive_request',
            'check-alive-response' => '\\StructType\\Check_alive_response',
            'get-metadata-request' => '\\StructType\\Get_metadata_request',
            'get-metadata-response' => '\\StructType\\Get_metadata_response',
            'BinaryImage' => '\\StructType\\BinaryImage',
            'MetaEnumList' => '\\StructType\\MetaEnumList',
            'StringEnumeration' => '\\StructType\\StringEnumeration',
            'StringEnumVal' => '\\StructType\\StringEnumVal',
            'NumberEnumeration' => '\\StructType\\NumberEnumeration',
            'NumberEnumVal' => '\\StructType\\NumberEnumVal',
            'DateEnumeration' => '\\StructType\\DateEnumeration',
            'DateEnumVal' => '\\StructType\\DateEnumVal',
            'DateTimeEnumeration' => '\\StructType\\DateTimeEnumeration',
            'DateTimeEnumVal' => '\\StructType\\DateTimeEnumVal',
            'TimeEnumeration' => '\\StructType\\TimeEnumeration',
            'TimeEnumVal' => '\\StructType\\TimeEnumVal',
            'BooleanEnumeration' => '\\StructType\\BooleanEnumeration',
            'BooleanEnumVal' => '\\StructType\\BooleanEnumVal',
            'UncertainEnumVal' => '\\StructType\\UncertainEnumVal',
            'ChildEnumValues' => '\\StructType\\ChildEnumValues',
            'MetaTable' => '\\StructType\\MetaTable',
            'MetaField' => '\\StructType\\MetaField',
            'MetaLink' => '\\StructType\\MetaLink',
            'load-request' => '\\StructType\\Load_request',
            'load-response' => '\\StructType\\Load_response',
            'save-request' => '\\StructType\\Save_request',
            'save-response' => '\\StructType\\Save_response',
            'CheckpointData' => '\\StructType\\CheckpointData',
            'set-checkpoint-request' => '\\StructType\\Set_checkpoint_request',
            'set-checkpoint-response' => '\\StructType\\Set_checkpoint_response',
            'get-checkpoint-request' => '\\StructType\\Get_checkpoint_request',
            'get-checkpoint-response' => '\\StructType\\Get_checkpoint_response',
            'request-fault' => '\\StructType\\Request_fault',
        );
    }
}
