<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for load-response StructType
 * @subpackage Structs
 */
class Load_response extends AbstractStructBase
{
    /**
     * The tables
     * Meta informations extracted from the WSDL
     * - documentation: An element containing the list of Tables retrieved by the request.
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\LoadData
     */
    public $tables;
    /**
     * Constructor method for load-response
     * @uses Load_response::setTables()
     * @param \StructType\LoadData $tables
     */
    public function __construct(\StructType\LoadData $tables = null)
    {
        $this
            ->setTables($tables);
    }
    /**
     * Get tables value
     * @return \StructType\LoadData
     */
    public function getTables()
    {
        return $this->tables;
    }
    /**
     * Set tables value
     * @param \StructType\LoadData $tables
     * @return \StructType\Load_response
     */
    public function setTables(\StructType\LoadData $tables = null)
    {
        $this->tables = $tables;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Load_response
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
