<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for set-checkpoint-request StructType
 * @subpackage Structs
 */
class Set_checkpoint_request extends AbstractStructBase
{
    /**
     * The checkpoint_data
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var \StructType\CheckpointData
     */
    public $checkpoint_data;
    /**
     * The request_context
     * Meta informations extracted from the WSDL
     * - documentation: This element contains additional parameters specified on the start session url. See Persist data using WSC.
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\RequestContext
     */
    public $request_context;
    /**
     * Constructor method for set-checkpoint-request
     * @uses Set_checkpoint_request::setCheckpoint_data()
     * @uses Set_checkpoint_request::setRequest_context()
     * @param \StructType\CheckpointData $checkpoint_data
     * @param \StructType\RequestContext $request_context
     */
    public function __construct(\StructType\CheckpointData $checkpoint_data = null, \StructType\RequestContext $request_context = null)
    {
        $this
            ->setCheckpoint_data($checkpoint_data)
            ->setRequest_context($request_context);
    }
    /**
     * Get checkpoint_data value
     * @return \StructType\CheckpointData
     */
    public function getCheckpoint_data()
    {
        return $this->{'checkpoint-data'};
    }
    /**
     * Set checkpoint_data value
     * @param \StructType\CheckpointData $checkpoint_data
     * @return \StructType\Set_checkpoint_request
     */
    public function setCheckpoint_data(\StructType\CheckpointData $checkpoint_data = null)
    {
        $this->checkpoint_data = $this->{'checkpoint-data'} = $checkpoint_data;
        return $this;
    }
    /**
     * Get request_context value
     * @return \StructType\RequestContext|null
     */
    public function getRequest_context()
    {
        return $this->{'request-context'};
    }
    /**
     * Set request_context value
     * @param \StructType\RequestContext $request_context
     * @return \StructType\Set_checkpoint_request
     */
    public function setRequest_context(\StructType\RequestContext $request_context = null)
    {
        $this->request_context = $this->{'request-context'} = $request_context;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Set_checkpoint_request
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
